import * as _pandacss_types from '@pandacss/types';
import { Config, RecipeVariantRecord, RecipeConfig, PatternConfig, Parts, SystemStyleObject, Preset, Tokens, SemanticTokens, CompositionStyles, GlobalStyleObject } from '@pandacss/types';

declare function defineConfig(config: Config): Config;
declare function defineRecipe<V extends RecipeVariantRecord>(config: RecipeConfig<V>): RecipeConfig<V>;
declare function definePattern(config: PatternConfig): PatternConfig;
declare function defineParts<T extends Parts>(parts: T): (config: Partial<Record<keyof T, SystemStyleObject>>) => Partial<Record<keyof T, SystemStyleObject>>;
declare function definePreset(preset: Preset): Preset;
type ProxyValue<T> = {
    [K in keyof T]: (definition: T[K]) => T[K];
};
declare const defineTokens: ProxyValue<Required<Tokens>>;
declare const defineSemanticTokens: ProxyValue<Required<SemanticTokens<string>>>;
declare function defineTextStyles(definition: CompositionStyles['textStyles']): _pandacss_types.TextStyles;
declare function defineLayerStyles(definition: CompositionStyles['layerStyles']): _pandacss_types.LayerStyles;
declare function defineGlobalStyles(definition: GlobalStyleObject): GlobalStyleObject;

export { defineConfig, defineGlobalStyles, defineLayerStyles, defineParts, definePattern, definePreset, defineRecipe, defineSemanticTokens, defineTextStyles, defineTokens };
